/******************************************************************/
/* ClassX Amiga Rexx script - Copyright  1996 ClassX Development */
/******************************************************************/

/*
	$VER: TUT_FontGroviera.rexx 1.0
	$INF: Esempio guidato per la creazione di un font dorato.
*/

MYPORT = 'FontMachine'

IF ~SHOW('P', MYPORT) THEN DO
	IF EXISTS('FontMachine:FontMachine') THEN DO
		ADDRESS COMMAND 'Run >NIL: FontMachine:FontMachine'
		DO 30 WHILE ~SHOW('P',MYPORT)
			 ADDRESS COMMAND 'Wait >NIL: 1 SEC'
		END
	END
	ELSE DO
		SAY "FontMachine could not be loaded."
		EXIT 10
	END
END

IF ~SHOW('P', MYPORT) THEN DO
	SAY 'FontMachine Rexx port could not be opened.'
	EXIT 10
END

ADDRESS VALUE MYPORT
OPTIONS RESULTS
OPTIONS FAILAT 10000

/******************************************************************/

/* Make sure rexxsupport library is opened */
IF ~SHOW('L','rexxsupport.library') THEN CALL ADDLIB('rexxsupport.library',0,-30)

LockGui

SetAttr "Emboss" 0
SetAttr "Bevel" 0
SetAttr "3D" 0
SetAttr "Shadow" 0
SetAttr "Outline" 0
SetAttr "OutTexture" 0

Request '"Tutorial Message"' '"Example 2: the making of a Gold font."' 'Ok'

Request '"Tutorial Message"' '"Set resolution to 16 colours"' 'Ok'
Resolution 4

Request '"Tutorial Message"' '"Load the font Balloon, size 100 points."' 'Ok'
LoadFont "Balloon.font" 100
CALL WaitRedraw (FM_RESULT)

Request '"Tutorial Message"' '"Load the front texture: Plasma 100x100 Gold."' 'Ok'
LoadTexture "Front" "Plasma" 100 100 0
CALL WaitRedraw (FM_RESULT)

Request '"Tutorial Message"' '"Load the border texture: Pattern 100x100 Gold Linear30."' 'Ok'
LoadTexture "Border" "Pattern" 100 100 0 "Linear30"
CALL WaitRedraw (FM_RESULT)

Request '"Tutorial Message"' '"Optimise the palette."' 'Ok'
OptimizePal

Request '"Tutorial Message"' '"Set the background colour to Blu."' 'Ok'
EditPal 0 0 0 180 
CALL WaitRedraw (FM_RESULT)

Request '"Tutorial Message"' '"Set Random Mapping (RndMap)."' 'Ok'
SetMapMode "SolidMappedRnd" 3
CALL WaitRedraw (FM_RESULT)

Request '"Tutorial Message"' '"Set 3 pixels border texture."' 'Ok'
SetAttr "OutTexture" 3
CALL WaitRedraw (FM_RESULT)


Request '"ARexx Message"' '"Done."' 'Ok'

UnLockGui
EXIT


/******************************************************************/

WaitRedraw:
	ARG Res
	/* wait the rendering of the font */
	DO WHILE Res ~= 0
		CheckRedraw
		Res = FM_RESULT
		ADDRESS COMMAND 'Wait >NIL: 1 SEC'
	END
	RETURN


/******************************************************************/
